searchNodes=[{"ref":"Inky.html","title":"Inky","type":"module","doc":"The Inky module provides the public API for interacting with the display."},{"ref":"Inky.html#child_spec/1","title":"Inky.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Inky.html#set_pixels/3","title":"Inky.set_pixels/3","type":"function","doc":"set_pixels sets pixels and draws to the display (or not!), with new pixel data or a painter function. Returns: :ok - If no push was requested or if it was and it worked, or {:error, :device_busy} - If a push to the device was requested but could not be performed due to the device reporting a busy status. Parameters pid - A pid or valid name option that can be provided to GenServer. arg - A map of pixels or a painter function. pixels :: map(), a map of pixels to merge into the current state. The map use the structure %{{x, y}: color} to indicate pixel coordinates and a color atom. painter :: (x, y, width, height, pixels), a function that will be invoked to pick a color for all points in the screen, in an undefined order. Should return a color atom. The color atoms :white :black :accent - The third color for a display. Usually red och yellow. :red - Equivalent to :accent. :yellow - Equivalent to :accent. Options :border - Atom for the border color. :push - Represents the minimum pixel pushing policy the caller wishes to apply for their request. Valid values are listed and explained below. NOTE: the internal state of Inky will still be updated, regardless of which pushing policy is employed. :await - Perform a blocking wait until the display is ready and you can push to it. Clears any previously set timeout. This is the default. :once - Push to the display if it is not busy, otherwise, report that it was busy. :await timeouts are reset if a :once push has failed. {:timeout, :await} - Use genserver timeouts to avoid multiple updates. When the timeout triggers, await device with a blocking wait and then push to the display. If the timeout previously was :once, it is replaced. {:timeout, :once} - Use genserver timeouts to avoid multiple updates. When the timeout triggers, update the display if not busy. Does not downgrade a previously set :await timeout. :skip - Do not push to display. If there has been a timeout previously set, but that has yet to fire, it will remain set."},{"ref":"Inky.html#show/2","title":"Inky.show/2","type":"function","doc":"Shows the internally buffered pixels on the display. If opts[:async] is true, the call will be asynchronous. Returns :ok."},{"ref":"Inky.html#start_link/3","title":"Inky.start_link/3","type":"function","doc":"Start an Inky GenServer for a display of type type, with the color accent using the optionally provided options opts. The GenServer deals with the HAL state and pushing pixels to the physical display. Parameters type - An atom, representing the display type, either :phat or :what accent - An atom, representing the display&#39;s third color, one of :black, :red or :yellow. Options border - Atom for the border color, defaults to :black name - GenServer name option for naming the process See GenServer.start_link/3 for return values."},{"ref":"Inky.html#stop/1","title":"Inky.stop/1","type":"function","doc":"Stops server. Returns :ok."},{"ref":"Inky.html#t:name/0","title":"Inky.name/0","type":"type","doc":"The Inky process name"},{"ref":"Inky.Display.html","title":"Inky.Display","type":"module","doc":"Display creates specifications for displays and accent colors"},{"ref":"Inky.Display.html#spec_for/2","title":"Inky.Display.spec_for/2","type":"function","doc":""},{"ref":"Inky.Display.html#t:t/0","title":"Inky.Display.t/0","type":"type","doc":""},{"ref":"Inky.HAL.html","title":"Inky.HAL","type":"behaviour","doc":"A behaviour for defining the command interface between Inky and an IO implementation"},{"ref":"Inky.HAL.html#c:handle_update/4","title":"Inky.HAL.handle_update/4","type":"callback","doc":""},{"ref":"Inky.HAL.html#c:init/1","title":"Inky.HAL.init/1","type":"callback","doc":""},{"ref":"Inky.HAL.html#t:io_state/0","title":"Inky.HAL.io_state/0","type":"type","doc":""},{"ref":"Inky.InkyIO.html","title":"Inky.InkyIO","type":"behaviour","doc":"A behaviour for defining how IO is performed on a specific platform."},{"ref":"Inky.InkyIO.html#c:handle_command/2","title":"Inky.InkyIO.handle_command/2","type":"callback","doc":""},{"ref":"Inky.InkyIO.html#c:handle_command/3","title":"Inky.InkyIO.handle_command/3","type":"callback","doc":""},{"ref":"Inky.InkyIO.html#c:handle_read_busy/1","title":"Inky.InkyIO.handle_read_busy/1","type":"callback","doc":""},{"ref":"Inky.InkyIO.html#c:handle_reset/2","title":"Inky.InkyIO.handle_reset/2","type":"callback","doc":""},{"ref":"Inky.InkyIO.html#c:handle_sleep/2","title":"Inky.InkyIO.handle_sleep/2","type":"callback","doc":""},{"ref":"Inky.InkyIO.html#c:init/1","title":"Inky.InkyIO.init/1","type":"callback","doc":""},{"ref":"Inky.InkyIO.html#t:init_opt/0","title":"Inky.InkyIO.init_opt/0","type":"type","doc":""},{"ref":"Inky.InkyIO.html#t:io_bit/0","title":"Inky.InkyIO.io_bit/0","type":"type","doc":""},{"ref":"Inky.InkyIO.html#t:io_command/0","title":"Inky.InkyIO.io_command/0","type":"type","doc":""},{"ref":"Inky.InkyIO.html#t:io_data/0","title":"Inky.InkyIO.io_data/0","type":"type","doc":""},{"ref":"Inky.InkyIO.html#t:io_state/0","title":"Inky.InkyIO.io_state/0","type":"type","doc":""},{"ref":"Inky.LookupTables.html","title":"Inky.LookupTables","type":"module","doc":"LookupTables are used for voltage control when updating the screen. LookupTables are explained in further detail in https://github.com/pimoroni/inky/blob/master/library/inky/inky.py#L95"},{"ref":"Inky.LookupTables.html#get_luts/1","title":"Inky.LookupTables.get_luts/1","type":"function","doc":""},{"ref":"Inky.LookupTables.html#t:accent/0","title":"Inky.LookupTables.accent/0","type":"type","doc":""},{"ref":"Inky.LookupTables.html#t:color/0","title":"Inky.LookupTables.color/0","type":"type","doc":""},{"ref":"Inky.LookupTables.html#t:variant/0","title":"Inky.LookupTables.variant/0","type":"type","doc":""},{"ref":"Inky.PixelUtil.html","title":"Inky.PixelUtil","type":"module","doc":"PixelUtil maps pixels to bitstrings to be sent to an Inky screen"},{"ref":"Inky.PixelUtil.html#normalised_rotation/1","title":"Inky.PixelUtil.normalised_rotation/1","type":"function","doc":"Only exposed for testing purposes. Do not use. iex&gt; Enum.map( ...&gt; [-360, -270, -180, -90, 0, 90, 180, 270, 360, 450], ...&gt; &amp;Inky.PixelUtil.normalised_rotation/1 ...&gt; ) [0, 1, 2, 3, 0, 1, 2, 3, 0, 1]"},{"ref":"Inky.PixelUtil.html#pixels_to_bits/5","title":"Inky.PixelUtil.pixels_to_bits/5","type":"function","doc":""},{"ref":"Inky.PixelUtil.html#rotation_opts/1","title":"Inky.PixelUtil.rotation_opts/1","type":"function","doc":"Only exposed for testing purposes. Do not use. iex&gt; Enum.map([3, 1, 2, 0], &amp;Inky.PixelUtil.rotation_opts/1) [{:x, {{:x, -1}, {:y, 1}}}, {:x, {{:x, 1}, {:y, -1}}}, {:y, {{:y, -1}, {:x, -1}}}, {:y, {{:y, 1}, {:x, 1}}}]"},{"ref":"Inky.RpiHAL.html","title":"Inky.RpiHAL","type":"module","doc":"An Inky.HAL implementation responsible for sending commands to the Inky screen. It delegates to whatever IO module its user provides at init, but defaults to Inky.RpiIO"},{"ref":"Inky.RpiIO.html","title":"Inky.RpiIO","type":"module","doc":"An Inky.InkyIO implementation intended for use with raspberry pis and relies on Circuits.GPIO and Cirtuits.SPI."},{"ref":"readme.html","title":"Readme","type":"extras","doc":"Inky This is a port of Pimoroni&#39;s python Inky library written in Elixir. This library is intended to support both Inky pHAT and wHAT, but since we only have pHATs, the wHAT support may not be fully functional. See the API reference for details on how to use the functionality provided. Host Development An inky host development library is underway for allowing host-side development, but until that is finished you can not see results without using a physical device. Scenic Driver A basic driver for scenic is in the works, check it out, to follow how it is progressing."},{"ref":"readme.html#getting-started","title":"Readme - Getting started","type":"extras","doc":"Inky is available on Hex. Add inky to your mix.exs deps: {:inky, &quot;~&gt; 1.0.1&quot;}, Run mix deps.get to get the new dep."},{"ref":"readme.html#usage","title":"Readme - Usage","type":"extras","doc":"A sample for Inky only, both host development and on-device is available as pappersverk/sample_inky. A sample for using it with Scenic both for host development and on-device is available as pappersverk/sample_scenic_inky."},{"ref":"readme.html#brief-example","title":"Readme - Brief example","type":"extras","doc":"In typical usage this would be inside a nerves project. If Inky is installed in your application you can do the following to test it and your display (note the config in init, adjust accordingly): # Start your Inky process ... {:ok, pid} = Inky.start_link(:phat, :red, %{name: InkySample}) painter = fn x, y, w, h, _pixels_so_far -&gt; wh = w / 2 hh = h / 2 case {x &gt;= wh, y &gt;= hh} do {true, true} -&gt; :red {false, true} -&gt; if(rem(x, 2) == 0, do: :black, else: :white) {true, false} -&gt; :black {false, false} -&gt; :white end end Inky.set_pixels(InkySample, painter, border: :white) # Flip a few pixels Inky.set_pixels(pid, %{{0,0}: :black, {3,49}: :red, {23, 4}: white})"}]